=begin
Copyright 2009, Matt
All Rights Reserved

THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

License:   Free

Author:     	Matthieu NOBLET
Organization:   Matt
Name:      		getpoint
Version:   		0.1
SU Version:   	6 and 7
Date:      		15/05/2009
Description:   	Should (...) return point clicked by user. Code, not a plugin!
Usage:      	pt=getpoint("Specify first point:")
History:
	0.100   15/05/2009
			First version, not finished
=end

class GetPoint
def initialize(msg)
	self.reset(nil) if msg.class!=String
	@msg=msg
	@ip=nil
	@pt=nil
end

def activate
	@ip=Sketchup::InputPoint.new
	@pt=Sketchup::InputPoint.new
	Sketchup::set_status_text @msg
end

def onMouseMove(flags, x, y, view)
	@ip.pick view, x, y
	if @ip.valid? && @ip!=@pt
		view.invalidate
		@pt.copy!(@ip)
	end
end

def onLButtonDown(flags, x, y, view)
	@pt.pick view, x, y
	self.reset(view)
end

def reset(view)
	if view
		view.tooltip=nil
		view.invalidate
	end
	Sketchup.send_action "selectSelectionTool:"
	puts @pt
end

def draw(view)
	@ip.draw(view) if @ip.valid? && @ip.display?
end

end # class

def getpoint(msg)
	Sketchup.active_model.select_tool(GetPoint.new(msg))
end
